<?php
/*
 *  stat4home
 *
 *  Tiny web statistics
 *
 *  by Michal Miszewski <m.miszewski at gmail.com>
 *
 *  version 0.1 (2003-09-12) - first public release
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.
 */

$items_per_page = 20;
$log_file = "log.txt";
$known_ip_list = "ip.txt";

error_reporting(E_ERROR);

header("Content-Type: text/html; charset=utf-8");	/* for badly configured servers */
echo "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Web site statistics</title>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="Content-Language" content="en" />
  <meta name="generator" content="stat4home" />
  <meta name="author" content="Michal Miszewski" />
  <meta name="description" content="Web site statistics" />
  <meta name="keywords" content="web, site, statistics, referer, page, pages, days, visits, hits, percent" />
  <link rel="stylesheet" title="Default" href="style.css" type="text/css" />
</head>
<body>
<h1>Web site statistics</h1>
<?php
printf("<p class=\"menu\"><a href=\"%s&pg=sum\">Summary</a> / <a href=\"%s&pg=ref\">Referers</a> / <a href=\"%s&pg=log\">Log</a></p>",
filter_query(''), filter_query(''), filter_query(''));

$week = array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
$year = array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September',
	'October', 'November', 'December');

$searchengs = array(	/* search engines */
	array('', '', '', ''),
	array('Google', 'http://google', 'http://www.google', 'q'),
	array('WP', 'http://szukaj.wp.pl', 'http://www.szukaj.wp.pl', 'szukaj'),
	array('Yahoo', 'http://search.yahoo.com', 'http://mx.search.yahoo.com', 'p'),
	array('AOL', 'http://aolsearch.aol', 'http://www.aolsearch.aol', 'query'),
	array('MSN', 'http://search.msn.com', 'http://search.msn.com', 'q'),
	array('mysearch', 'http://ki.mysearch.myway.com', 'http://www.mywebsearch.com', 'searchfor'),
	array('AlltheWeb.com', 'http://alltheweb.com/search', 'http://www.alltheweb.com/search', '_b_query'),
	array('Onet', 'http://www.szukaj.onet.pl', 'http://szukaj.onet.pl', 'qt'),
	array('Szukacz.pl', 'http://szukacz.pl/szukaj', 'http://www.szukacz.pl/szukaj', 'q')
);

$have_buffered_known_ip_list = FALSE;

function sanitize($link)
{
	$ret = urldecode($link);
	$ret = htmlspecialchars($ret);
	return $ret;
}

function zero($val)
{
	if (strlen($val) < 2)
		$ret = sprintf("0%s", $val);
	else
		$ret = sprintf("%s", $val);
	return $ret;
}

function known_ip($ip)
{
	global $have_buffered_known_ip_list;
	global $buffered_known_ip_list;
	global $known_ip_list;

	if ($have_buffered_known_ip_list == TRUE) {
		if ($buffered_known_ip_list[$ip] != "")
			return "$buffered_known_ip_list[$ip]";
	} else {
		if (is_readable($known_ip_list)) {
			$iplist = fopen($known_ip_list, "r");
			$have_buffered_known_ip_list = TRUE;
			do {
				$line = fgetcsv($iplist, 2000);
				if (feof($iplist))
					break;
				$buffered_known_ip_list[$line[0]] = $line[1];
				if ($line[0] == $ip)
					$ip = $line[1];
			} while(1);
			fclose($iplist);
		}
	}

	return $ip;
}

function get_query($url, $arg) {
	$parsed_url = parse_url($url);
	parse_str($parsed_url['query'], $url_query);
	return $url_query[$arg];
}

function filter_query($ip) {
	global $filter_syear;
	global $filter_smonth;
	global $filter_sday;
	global $filter_tyear;
	global $filter_tmonth;
	global $filter_tday;
	global $filter_ip;
	$filter_syear = $_REQUEST['syear'];
	$filter_smonth = $_REQUEST['smonth'];
	$filter_sday = $_REQUEST['sday'];
	$filter_tyear = $_REQUEST['tyear'];
	$filter_tmonth = $_REQUEST['tmonth'];
	$filter_tday = $_REQUEST['tday'];
	$filter_ip = $_REQUEST['ip'];

	$ret = "";
	if ($ip != '') $filter_ip = $ip;
	if ($filter_syear != '') $ret = $ret."&syear=".$filter_syear;
	if ($filter_smonth != '') $ret = $ret."&smonth=".$filter_smonth;
	if ($filter_sday != '') $ret = $ret."&sday=".$filter_sday;
	if ($filter_tyear != '') $ret = $ret."&tyear=".$filter_tyear;
	if ($filter_tmonth != '') $ret = $ret."&tmonth=".$filter_tmonth;
	if ($filter_tday != '') $ret = $ret."&tday=".$filter_tday;
	if ($filter_ip != '') $ret = $ret."&ip=".$filter_ip;
	if ($ret == '')
		$ret = "?f=0";
	else
		$ret = "?f=1".$ret;
	return $ret;
}

function search_engine_name($num)
{
	global $searchengs;

	return $searchengs[$num][0];
}

function is_search_query($url)
{
	global $searchengs;

	if ($url != "") {
		for ($a = 0; $a < sizeof($searchengs); $a++)
			if ($searchengs[$a][1] != '')
			if ((stristr($url, $searchengs[$a][1]) != FALSE) ||
			(stristr($url, $searchengs[$a][2]) != FALSE))
			return $a;
	}

	return 0;	/* normal link */
}

function un_search_query($link, $searcheng)
{
	global $searchengs;

	if ($searcheng == 0)
		$bar = $link;
	else
		$bar = get_query($link, $searchengs[$searcheng][3]);

	return $bar;
}

function format_referer_link($url)
{
	if ($url != "") {
		$ret = is_search_query($url);
		if ($ret != 0) {
			$words = un_search_query($url, $ret);
			$words = sanitize($words);
			$html = sprintf("%s <a href=\"%s\">search</a>: %s", search_engine_name($ret), sanitize($url), $words);
		} else {
			$html = sprintf("<a href=\"%s\">%s</a>", sanitize($url), sanitize($url));
		}
		return $html;
	} else
		return "&nbsp;";
}

function percentage($number, $total)
{
	if ($total == 0) return "0%";
	$ret = sprintf("%.1f%%", ($number / $total) * 100);
	return $ret;
}

function percent_bar($number, $total)
{
	$bar = "";
	for ($a = 0; $a < (int)(($number / $total) * 60); $a++)
		$bar .= "#";
	$ret = sprintf("<img src=\"bar.png\" width=\"%d\" height=\"10\" alt=\"%s\" />",
		($number / $total) * 500, $bar);
	return $ret;
}

function print_log_line($line, $lineno)
{
	$link = $line[9];
	$link = format_referer_link($link);
	printf("<tr><td>%s-%s-%s</td><td>%s:%s</td><td><a href=\"?pg=det&ln=%d\">details</a></td><td>%s</td><td>%s</td><td>%s</td></tr>\n",
	$line[2], zero($line[1]), zero($line[0]), zero($line[4]), zero($line[5]), $lineno, known_ip($line[6]), $line[7], $link);
}

function print_referer_line($line, $lineno)
{
	$link = $line[9];
	$link = format_referer_link($link);
	printf("<tr><td><a href=\"?pg=det&amp;ln=%d\">details</a></td><td>%s</td><td>%s</td></tr>\n",
	$lineno, $line[7], $link);
}

function seek_line($file, $line)
{
	$count = 0;

	rewind($file);

	if ($line == 0)
		return TRUE;

	do {
		if ($count == $line) {
			break;
		}
		if (feof($file)) {
			if ($count < $line)
				return FALSE;
			break;
		}
		fgets($file, 2000);
		$count++;
	} while(1);

	return TRUE;
}

function seek_line_referer_only($file, $line)
{
	$count = 0;
	$lineno = 0;

	rewind($file);

	if ($line == 0)
		return 0;

	do {
		if ($count == $line) {
			break;
		}
		if (feof($file))
			break;
		$csv = fgetcsv($file, 2000);
		if (($csv[9] != "") && ($csv[9] != " "))
			$count++;
		$lineno++;
	} while(1);

	return $lineno;
}

function count_lines($file)
{
	global $first_date;
	global $last_date;

	$count = 0;

	rewind($file);
	do {
		if (($line != "") && (filter_passed($line))) {
			$count++;
			if ($first_date == "")
				$first_date = sprintf("%s-%s-%s", $line[2], zero($line[1]), zero($line[0]));
		}
		$oldline = $line;
		$line = fgetcsv($file, 2000);
	} while (!(feof($file)));

	$last_date = sprintf("%s-%s-%s", $oldline[2], zero($oldline[1]), zero($oldline[0]));

	return $count;
}

function count_lines_with_referer($file)
{
	$count = 0;

	rewind($file);
	do {
		if (($line[9] != "") && ($line[9] != " "))
			$count++;
		$line = fgetcsv($file, 2000);
	} while (!(feof($file)));

	return $count;
}

function page_navigation($start, $num_lines)
{
	global $items_per_page;

	$current_page = ($start / $items_per_page) + 1;
	$num_pages = ($num_lines / $items_per_page);
	if (($num_lines % $items_per_page) != 0)
		$num_pages++;
	echo "<p class=\"navigation\">";
	if ($start != "") {
		if ($start - $items_per_page >= 0)
			$pos = $start - $items_per_page;
		else
			$pos = 0;
		if ($start != 0)
			printf("<a href=\"%s&amp;pg=%s&amp;start=0\">&lt;&lt; First</a>&nbsp;&nbsp;<a href=\"%s&amp;pg=%s&amp;start=%d\">&lt; Previous</a> | ",
			filter_query(''), $_REQUEST['pg'], filter_query(''), $_REQUEST['pg'], $pos);
	}
	printf("page <b>%d</b> of <b>%d</b>", (int)$current_page, (int)$num_pages);
	if ((int)$num_pages > (int)$current_page)
		printf(" | <a href=\"%s&amp;pg=%s&amp;start=%d\">Next &gt;</a>&nbsp;&nbsp;<a href=\"%s&amp;pg=%s&amp;start=%d\">Last &gt;&gt;</a>",
		filter_query(''), $_REQUEST['pg'], $start + $items_per_page, filter_query(''), $_REQUEST['pg'],
		($items_per_page * ((int)$num_pages - 1)));
	echo "</p>\n";
}

function open_log()
{
	global $log_file;
	global $file;

	if (!(is_readable($log_file))) {
		echo "<p class=\"error\"><b>Error:</b> Can't open log file <b>$log_file</b>\n</p>";
		return 0;
	}

	$file = fopen($log_file, 'r');
	return 1;
}

function display_log()
{
	global $file;
	global $items_per_page;

	$items_on_page = 0;
	$lineno = 0;
	$start = $_REQUEST['start'];

	$lines = count_lines($file);
	echo "<h2>Log</h2>";
	if ($lines == 0) {
		echo "<p>Log file is empty.</p>\n";
		return;
	}
	if ($start != "") {
		seek_line($file, $start);
	} else
		rewind($file);
	page_navigation($start, $lines);
	echo "<hr />\n";
	echo "<div style=\"text-align: center\">\n";
	echo "<table style=\"display: inline\">\n";
	echo "<tr><th>Date</th><th>Time</th><th>Details</th><th>IP</th><th>Page</th><th>Referer address</th></tr>\n";
	do {
		$line = fgetcsv($file, 2000);
		if (feof($file))
			break;
		if (filter_passed($line)) {
			print_log_line($line, $lineno + $start);
			$items_on_page++;
		}
		if ($items_on_page == $items_per_page)
			break;
		$lineno++;
	} while(1);
	echo "</table>\n";
	echo "</div>\n";
	echo "<hr />\n";
	page_navigation($start, $lines);

	fclose($file);
}

function display_referers()
{
	global $file;
	global $items_per_page;

	$lineno = 0;
	$items_on_page = 0;
	$start = $_REQUEST['start'];

	$lines = count_lines_with_referer($file);
	echo "<h2>Referer addresses</h2>";
	if ($lines == 0) {
		echo "<p>Log file contains no hits with referer addresses.</p>\n";
		return;
	}
	if ($start != "") {
		$lineno = seek_line_referer_only($file, $start);
	} else
		rewind($file);
	page_navigation($start, $lines);
	echo "<hr />\n";
	echo "<div style=\"text-align: center\">\n";
	echo "<table style=\"display: inline\">\n";
	echo "<tr><th>Details</th><th>Page</th><th>Referer address</th></tr>\n";
	do {
		$line = fgetcsv($file, 2000);
		if (feof($file))
			break;
		if (($line[9] != "") && ($line[9] != " ")) {
			print_referer_line($line, $lineno);
			$items_on_page++;
		}
		$lineno++;
		if ($items_on_page == $items_per_page)
			break;
	} while(1);
	echo "</table>\n";
	echo "</div>\n";
	echo "<hr />\n";
	page_navigation($start, $lines);

	fclose($file);
}

function line_details($lineno)
{
	global $file;

	seek_line($file, $lineno);
	$csv = fgetcsv($file, 2000);
	$hostname = gethostbyaddr($csv[6]);
	if ($hostname == $csv[6])
		$hostname = "<i>unresolved</i>";
	$referer = $csv[9];
	if (($referer == "") || ($referer == " "))
		$referer = "<i>empty</i>";	
	else
		$referer = format_referer_link($referer);
	$ip = $csv[6];
	if (($name = known_ip($csv[6])) != $csv[6])
		$ip = sprintf("%s (%s)", $csv[6], $name);
	else
		$ip = $csv[6];
	echo "<h2>Details</h2>\n";
	echo "<dl>\n";
	echo "<dt>Date</dt>\n";
	printf("<dd>%s-%s-%s</dd>\n", $csv[2], zero($csv[1]), zero($csv[0]));
	echo "<dt>Time</dt>\n";
	printf("<dd>%s:%s</dd>\n", zero($csv[4]), zero($csv[5]));
	echo "<dt>IP</dt>\n";
	printf("<dd>%s</dd>\n", $ip);
	echo "<dt>Hostname</dt>\n";
	printf("<dd>%s</dd>\n", $hostname);
	echo "<dt>Visited page</dt>\n";
	printf("<dd>%s</dd>\n", $csv[7]);
	echo "<dt>Browser identification string</dt>\n";
	printf("<dd>%s</dd>\n", htmlspecialchars($csv[8]));
	echo "<dt>Referer address</dt>\n";
	printf("<dd>%s</dd>\n", $referer);
	echo "</dl>\n";
}

/* formats and displays the hours statistics summary */
function hours_summary($hours, $visits)
{
	global $week;

	echo "<h2>Hours</h2>\n";
	echo "<table>\n<tr><th>Hour</th><th>Hits</th><th>Visits</th><td class=\"noframe\">&nbsp;</td></tr>\n";
	for ($a = 1; $a < 25; $a++) {
		if ($hours[$a]['hits'] > 0) {
			printf("<tr><td>%d</td><td>%d</td><td>%d</td><td class=\"noframe\">%s</td></tr>\n", $a, $hours[$a]['hits'],
			$hours[$a]['visits'], percent_bar($hours[$a]['visits'], $visits));
		}
	}
	echo "</table>\n";
}

/* formats and displays the weekdays statistics summary */
function weekdays_summary($weekdays, $visits, $hits)
{
	global $week;

	echo "<h2>Days of the week</h2>\n";
	echo "<table>\n<tr><th>Day of the week</th><th>Hits</th><th>Visits</th><td class=\"noframe\">&nbsp;</td></tr>\n";

	for ($a = 0; $a < 7; $a++) {
		printf("<tr><td>%s</td><td>%d (%s)</td><td>%d (%s)</td><td class=\"noframe\">%s</td></tr>\n", $week[$a],
		$weekdays[$a]['hits'], percentage($weekdays[$a]['hits'], $hits),
		$weekdays[$a]['visits'], percentage($weekdays[$a]['visits'], $visits),
		percent_bar($weekdays[$a]['visits'], $visits));
	}

	echo "</table>\n";
}

/* formats and displays the months statistics summary */
function months_summary($months)
{
}

/* formats and displays the subpages statistics summary */
function subpages_summary($pages, $visits, $hits)
{
	echo "<h2>Subpages</h2>\n";
	echo "<table>\n<tr><th>Page</th><th>Hits</th><th>Visits</th><td class=\"noframe\">&nbsp;</td></tr>\n";

	foreach ($pages as $pagename => $values) {
		printf("<tr><td>%s</td><td>%d (%s)</td><td>%d (%s)</td><td class=\"noframe\">%s</td></tr>\n", $pagename,
		$values['hits'], percentage($values['hits'], $hits),
		$values['visits'], percentage($values['visits'], $visits), percent_bar($values['visits'],
		$visits));
	}

	printf("<tr><th>Total:</th><td>%d</td><td>%d</td><td class=\"noframe\">&nbsp;</td></tr>\n", $hits, $visits);
	echo "</table>\n";
}

/* formats and displays the known hosts statistics summary */
function known_hosts_summary($known_hosts)
{
	$was = FALSE;
	echo "<h2>Known hosts</h2>\n";

	if (sizeof($known_hosts) > 0) {
		foreach ($known_hosts as $name => $values) {
			if (!($was)) {
				echo "<table>\n<tr><th>Name</th><th>Visits</th><th>Hits</th><th>First hit</th><th>Last hit</th></tr>\n";
				$was = TRUE;
			}
			printf("<tr><td><a href=\"%s\">%s</a></td><td>%d</td><td>%d</td><td>%s</td><td>%s</td></tr>\n",
			filter_query($name), $name, $values['visits'], $values['hits'], $values['first'], $values['last']);
		}
	}
	if ($was)
		echo "</table>\n";
	else
		echo "<p>No hits from known hosts.</p>\n";
}

function searchengs_summary($searchengs, $search_visits, $totalvisits)
{
	echo "<h2>Search engines</h2>\n";
	if ($search_visits == 0) {
		echo "<p>Noticed no visits from search engines.</p>\n";
		return;
	}
	echo "<p>Search engines used to find and visit your site:</p>\n";
	echo "<table>\n<tr><th>Search engine</th><th>Visits</th><td class=\"noframe\">&nbsp;</td></tr>\n";
	foreach ($searchengs as $name => $visits) {
		printf("<tr><td>%s</td><td>%d (%s)</td><td class=\"noframe\">%s</td></tr>\n", $name, $visits,
		percentage($visits, $search_visits), percent_bar($visits, $search_visits));
	}
	printf("<tr><th>Total:</th><td>%d</td><td class=\"noframe\">&nbsp;</td></tr>\n", $search_visits);
	echo "</table>\n";
	printf("<p><b>%d%%</b> of all visitors found the site using one of the above search engines.</p>\n",
	percentage($search_visits, $totalvisits));
}

/* return TRUE if the line is not filtered out by applied filter */
function filter_passed($line) {
	global $filter_valid;

	if (($_REQUEST['f'] == 1) && ($filter_valid)) {
		global $filter_syear;
		global $filter_smonth;
		global $filter_sday;
		global $filter_tyear;
		global $filter_tmonth;
		global $filter_tday;
		global $filter_ip;
		$filter_syear = $_REQUEST['syear'];
		$filter_smonth = $_REQUEST['smonth'];
		$filter_sday = $_REQUEST['sday'];
		$filter_tyear = $_REQUEST['tyear'];
		$filter_tmonth = $_REQUEST['tmonth'];
		$filter_tday = $_REQUEST['tday'];
		$filter_ip = $_REQUEST['ip'];

		if ($filter_syear != '') {
			if (!(($line[2] >= $filter_syear) && ($line[2] <= $filter_tyear)))
				return FALSE;
			if ($line[2] == $filter_syear) {
				if ($line[1] < $filter_smonth)
					return FALSE;
			}
			if ($line[1] == $filter_tyear) {
				if ($line[1] > $filter_tmonth)
					return FALSE;
			}
			if ($line[1] == $filter_smonth) {
				if ($line[0] < $filter_sday)
					return FALSE;
			}
			if ($line[1] == $filter_tmonth) {
				if ($line[0] > $filter_tday)
					return FALSE;
			}
		}
		if (($filter_ip) != '') {
			if (($line[6] != $filter_ip) && (known_ip($line[6]) != $filter_ip))
				return FALSE;
		}
	}
	return TRUE;
}

function filter_valid() {
	if ($_REQUEST['f'] == 1) {
		$syear = $_REQUEST['syear'];
		$smonth = $_REQUEST['smonth'];
		$sday = $_REQUEST['sday'];
		$tyear = $_REQUEST['tyear'];
		$tmonth = $_REQUEST['tmonth'];
		$tday = $_REQUEST['tday'];
		$ip = $_REQUEST['ip'];

		if ($syear > $tyear) return FALSE;
		if ($syear == $tyear) {
			if ($smonth > $tmonth) return FALSE;
			if ($smonth == $tmonth) {
				if ($sday > $tday) return FALSE;
			}
		}
	}
	return TRUE;
}

/* gathers data for summary statistics */
function run_forest_run() 
{
	global $file;
	global $first_date;
	global $last_date;

	$first_date = "";
	$last_date = "";
	$date = "";
	$hits = 0;
	$visits = 0;
	$days = 0;
	$search_visits = 0;
	$ip = $_REQUEST['ip'];

	do {
		$line = fgetcsv($file, 2000);
		if (feof($file))
			break;
		if (filter_passed($line)) {
			if ($first_date == "")
				$first_date = sprintf("%s-%s-%s", $line[2], zero($line[1]), zero($line[0]));
			$last_date = sprintf("%s-%s-%s", $line[2], zero($line[1]), zero($line[0]));
			if ($date != "$line[0]$line[1]$line[2]") {
				$days++;
				$date = "$line[0]$line[1]$line[2]";
			}
			$known = known_ip($line[6]);
			if ($known != $line[6]) {	/* one of our known IPs */
				$known_hosts[$known]['hits']++;
				if ($known_hosts[$known]['first'] == NULL)
					$known_hosts[$known]['first'] = "$line[2]-$line[1]-$line[0]";
				$known_hosts[$known]['last'] = "$line[2]-$line[1]-$line[0]";
			} else
				$known = FALSE;
			/* counting visits and hits for separate subpages */
			if ($pages[$line[7]][$line[6]] != "$line[0]$line[1]$line[2]") {
				$pages[$line[7]][$line[6]] = "$line[0]$line[1]$line[2]";
				$pages[$line[7]]['visits']++;
				$visits++;	/* counting total visits */
				$hours[$line[4]]['visits']++;
				$weekdays[$line[3]]['visits']++;	/* counting hits for week days */
				$months[$line[2]][$line[1]]['visits']++;	/* counting visits for month days */
				if ($known != FALSE)
					$known_hosts[$known]['visits']++;
				if (($num = is_search_query($line[9])) != 0) {
					$searchengs[search_engine_name($num)]++;
					$search_visits++;
				}
			}
			$pages[$line[7]]['hits']++;
			$hits++;	/* counting total hits */
			$hours[$line[4]]['hits']++;
			$weekdays[$line[3]]['hits']++;	/* counting hits for week days */
			$months[$line[2]][$line[1]]['hits']++;	/* counting hits for month days */
		}
	} while(1);

	echo("<h2>Summary</h2>");
	if ($hits > 0) {
		if ($ip != "") printf("<p>Statistics for <b>%s</b>.</p>", $ip);
		printf("<p>Statistics since <b>%s</b> to <b>%s</b> (<b>%d</b> days).</p>", $first_date, $last_date, $days);
		printf("<p>Total visits: <b>%d</b> (<b>%d</b>/day), total hits: <b>%d</b> (<b>%d</b>/day).</p>\n",
		$visits, $visits / $days, $hits, $hits / $days);
		subpages_summary($pages, $visits, $hits);
		hours_summary($hours, $visits);
		weekdays_summary($weekdays, $visits, $hits);
		months_summary($months);
		known_hosts_summary($known_hosts);
		searchengs_summary($searchengs, $search_visits, $visits);
	} else {
		echo "<p>No hits found.</p>\n";
	}
}

function filter_show() {
	global $first_date;
	global $last_date;
	global $filter_valid;

	$page = $_REQUEST['pg'];
	$ip = $_REQUEST['ip'];
	$f = $_REQUEST['f'];
	$first = explode("-", $first_date);
	$last = explode("-", $last_date);

	echo "<h2>Filter</h2>\n";
	if (!($filter_valid))
		echo "<p class=\"error\"><b>Error</b>: <i>To</i> date must be later than <i>since</i>.</p>\n";

	echo "<form method=\"get\" action=\"index.php\">
<table>
<tr class=\"noframe\">
<td><b>Since:</b></td>
<td><input type=\"text\" name=\"syear\" value=\"$first[0]\" size=\"4\" maxlength=\"4\" class=\"field\" />-
<input type=\"text\" name=\"smonth\" value=\"$first[1]\" size=\"2\" maxlength=\"2\" class=\"field\" />-
<input type=\"text\" name=\"sday\" value=\"$first[2]\" size=\"2\" maxlength=\"2\" class=\"field\" /></td>
</tr>
<tr class=\"noframe\">
<td><b>To:</b></td>
<td><input type=\"text\" name=\"tyear\" value=\"$last[0]\" size=\"4\" maxlength=\"4\" class=\"field\" />-
<input type=\"text\" name=\"tmonth\" value=\"$last[1]\" size=\"2\" maxlength=\"2\" class=\"field\" />-
<input type=\"text\" name=\"tday\" value=\"$last[2]\" size=\"2\" maxlength=\"2\" class=\"field\" /></td>
</tr>
<tr class=\"noframe\">
<td><b>IP:</b></td>
<td><input type=\"text\" name=\"ip\" value=\"$ip\" size=\"30\" maxlength=\"\" class=\"field\" /></td>
</tr>
<tr class=\"noframe\">
<td></td>
<td>
<input type=\"hidden\" name=\"pg\" value=\"$page\" class=\"field\" />
<input type=\"hidden\" name=\"f\" value=\"1\" class=\"field\" />
<input type=\"submit\" value=\"Apply\" class=\"button\" />
</td>
</tr>
</table>
</form>";

	if ($f != 0) {
		if ($page == "")
			$page = "sum";
		echo "<p><b>Filter applied</b>. <a href=\"?pg=$page\">Reset filter</a></p>";
	}
}

if (open_log()) {
	if ($_REQUEST['pg'] == "log") {
		$filter_valid = filter_valid();
		display_log();
		filter_show();
	} else if ($_REQUEST['pg'] == "ref") {
		display_referers();
	} else if ($_REQUEST['pg'] == "det") {
		line_details($_REQUEST['ln']);
	} else {
		$filter_valid = filter_valid();
		run_forest_run();
		filter_show();
	}
}

?>
<p class="foot">Generated using <a href="http://mrm.qwe.pl/stat4home/">stat4home</a> by
<a href="http://mrm.qwe.pl/">Michał Miszewski</a>. This site is valid
<a href="http://validator.w3.org/check/referer/">XHTML 1.0</a>
and <a href="http://jigsaw.w3.org/css-validator/">CSS</a>. Powered by
<a href="http://www.php.net/">PHP</a>.</p>
</body>
</html>
